/*

Boost Software License - Version 1.0 - August 17th, 2003

Permission is hereby granted, free of charge, to any person or organization
obtaining a copy of the software and accompanying documentation covered by
this license (the "Software") to use, reproduce, display, distribute,
execute, and transmit the Software, and to prepare derivative works of the
Software, and to permit third-parties to whom the Software is furnished to
do so, all subject to the following:

The copyright notices in the Software and this entire statement, including
the above license grant, this restriction and the following disclaimer,
must be included in all copies of the Software, in whole or in part, and
all derivative works of the Software, unless such copies or derivative
works are solely in the form of machine-executable object code generated by
a source language processor.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.

*/
module derelict.opengl3.types;

alias uint GLenum;
alias void GLvoid;
alias ubyte GLboolean;
alias uint GLbitfield;
alias char GLchar;
alias byte GLbyte;
alias short GLshort;
alias int GLint;
alias int GLsizei;
alias ubyte GLubyte;
alias ushort GLushort;
alias uint GLuint;
alias ushort GLhalf;
alias float GLfloat;
alias float GLclampf;
alias double GLdouble;
alias double GLclampd;
alias ptrdiff_t GLintptr;
alias ptrdiff_t GLsizeiptr;

// ARB_vertex_buffer_object
alias ptrdiff_t GLintptrARB;
alias ptrdiff_t GLsizeiptrARB;

// ARB_shader_objects
alias byte GLcharARB;
alias uint GLhandleARB;

// ARB_half_float_pixel
alias ushort GLhalfARB;

// NV_half_float
alias ushort GLhalfNV;

// EXT_timer_query
alias long GLint64EXT;
alias ulong GLuint64EXT;

// ARB_sync
alias long GLint64;
alias ulong GLuint64;
struct __GLsync;
alias __GLsync* GLsync;

// ARB_cl_event
struct _cl_context;
struct _cl_event;

// ARB_debug_output
extern(System) alias void function(GLenum, GLenum, GLuint, GLenum, GLsizei, in GLchar*, GLvoid*) GLDEBUGPROCARB;

// AMD_debug_output
extern(System) alias void function(GLuint, GLenum, GLenum, GLsizei, in GLchar*, GLvoid*) GLDEBUGPROCAMD;

// This is a Derelict type, not from OpenGL
enum GLVersion
{
    None,
    GL11 = 11,
    GL12 = 12,
    GL13 = 13,
    GL14 = 14,
    GL15 = 15,
    GL20 = 20,
    GL21 = 21,
    GL30 = 30,
    GL31 = 31,
    GL32 = 32,
    GL33 = 33,
    GL40 = 40,
    GL41 = 41,
    GL42 = 42,
    HighestSupported = GL42,
}